#!/bin/bash
#
#    Crea una bdd para ldap desde un drupal.    
#
#    Copyright (C) 2011  rotobator@gmail.com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


function check_db(){
#$1 db dir
#return true if if id2entry.bdb && dn2id.bdb are ok
   if [ ! -e .total_users ];then
      echo "Number of exported users unknown"
      exit 1
   fi

   e=`[ -x /usr/bin/db4.6_stat ] && echo -ne /usr/bin/db4.6_stat || echo -ne /usr/bin/db4.7_stat`
   if [ ! -x $e ];then
      echo "Check DB failed. Please install db4.6-util or db4.7-util (db4.6_stat)"
      exit 1
   fi

   nre=`cat .total_users|cut -f2 -d=`
   nr1=`$e -d "$1/id2entry.bdb"|grep "Number of unique keys in the tree"|tr -d '[a-zA-Z\ ]'`
   nr2=`$e -d "$1/dn2id.bdb"|grep "Number of unique keys in the tree"|tr -d '[a-zA-Z\ ]'`

   [ $nr1 -ge $nre -a $nr2 -ge $nre ] && exit 0

   echo "Check DB failed. Less than 90% of users imported!"
   exit 1
}


r=`mktemp` 
add="/usr/sbin/slapadd"
bulk_conf="/etc/ldap/slapd_bulk_load.conf"
conf="/etc/ldap/slapd.conf"
dir=`grep ^directory $bulk_conf|cut -f2 -d\"`
dir_prod=`grep ^directory $conf|cut -f2 -d\"`


[ -s $bulk_conf -a -s $conf ] || exit 1
[ -x generate_ldiff.sh ] || exit 2
[ -e ldap_import_functions.sh ] || exit 3
[ "x$1" = "x" ] && echo "Uso: $0 <drupal6|wordpress>" && exit 4
[ -x ./export_$1_users.sh ] || exit 5


. ./ldap_import_functions.sh
[ $dir = "/" -o $dir_prod = "/" ] && exit 6
[ -d $dir ] || mkdir $dir
rm -f $dir/*

./generate_ldiff.sh $1 > $r || exit 7

$add -c -f $bulk_conf -b "$dn" -l $r
rm -f $r

check_db $dir || exit 8

/etc/init.d/slapd stop
cp -a $dir/* $dir_prod/
chown -R $openldap_user.$openldap_group $dir_prod
/etc/init.d/slapd start
